void ElaAnal() {
   Int_t nbytes = 0;
   Int_t Pi = 3.1415;
   Int_t i,jet, par, jetpar;
   Float_t Ptjet[20], Etajet[20], Phijet[20];
   Int_t jet, jet1,jet2, ibin, iibin;
   Float_t Xmas,  Ptjet, Corr;
   Float_t Angle, Eta;

// ...........loop over entries..................

   Int_t nentries = chain->GetEntries();
   printf("Total number of entries in chain = %d\n",nentries);
   for (i=0; i<nentries;i++) {
     if(i % 1000 ==0) printf("analysed:%d\n",i);
     nbytes += chain.GetEvent(i);
// .... calculate Pt, Eta, Phi for jets
     for (jet=0;jet<Njeta;jet++) {
        Ptjet[jet]=TMath::Sqrt( Pxjet[jet]*Pxjet[jet]
                               +Pyjet[jet]*Pyjet[jet]);
        Etajet[jet]=Eta(Ptjet[jet],Pzjet[jet]);
        Phijet[jet]=Angle(Pxjet[jet],Pyjet[jet]);
     }

// .... calculate mass for uncalibrated jets
      for (jet1=0;jet1<Njeta-1;jet1++) {
        for (jet2=jet1+1;jet2<Njeta;jet2++) {
          if(abs(Kfjet[jet1])==5 && abs(Kfjet[jet2])==5)  {
            Ptj_cru.Fill(Ptjet[jet1]);
            Ptj_cru.Fill(Ptjet[jet2]);
            Xmas= (Eejet[jet1]+Eejet[jet2])*(Eejet[jet1]+Eejet[jet2])
                 -(Pzjet[jet1]+Pzjet[jet2])*(Pzjet[jet1]+Pzjet[jet2])
                 -(Pyjet[jet1]+Pyjet[jet2])*(Pyjet[jet1]+Pyjet[jet2])
                 -(Pxjet[jet1]+Pxjet[jet2])*(Pxjet[jet1]+Pxjet[jet2]);
            if(Xmas>0.001) Xmas=TMath::Sqrt(Xmas);
            Mbb_cru.Fill(Xmas);
          } 
        }
      }
// .... recalibrate jets
      for (jet=0;jet<Njeta;jet++) {
        Corr=Kfac->GetBinContent(50);
        ibin= TMath::Nint((Ptjet[jet]-0.0)/(100.0-0.0)*50)+1;
        for (iibin=0; iibin<50;iibin++) {
           if(iibin == ibin) Corr=Kfac.GetBinContent(iibin);
        }
        Pxjet[jet]=Pxjet[jet]*Corr;
        Pyjet[jet]=Pyjet[jet]*Corr;
        Pzjet[jet]=Pzjet[jet]*Corr;
        Eejet[jet]=Eejet[jet]*Corr;
        Ptjet[jet]=Ptjet[jet]*Corr;
      }
   
// .... calculate mass for calibrated jets

      for (jet1=0;jet1<Njeta-1;jet1++) {
         for (jet2=jet1+1;jet2<Njeta;jet2++) {
            if(abs(Kfjet[jet1])==5 && abs(Kfjet[jet2])==5)  {
               Ptj.Fill(Ptjet[jet1]);
               Ptj.Fill(Ptjet[jet2]);
               Xmas= (Eejet[jet1]+Eejet[jet2])*(Eejet[jet1]+Eejet[jet2])
                    -(Pzjet[jet1]+Pzjet[jet2])*(Pzjet[jet1]+Pzjet[jet2])
                    -(Pyjet[jet1]+Pyjet[jet2])*(Pyjet[jet1]+Pyjet[jet2])
                    -(Pxjet[jet1]+Pxjet[jet2])*(Pxjet[jet1]+Pxjet[jet2]);
               if(Xmas>0.001) Xmas=TMath::Sqrt(Xmas);
               Mbb.Fill(Xmas); 
            } 
         }
      }
   }
}
